stages:
  - build
  - test
  - pages

variables:
  IMAGE_TEST: "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}-test"
  IMAGE_PUBLISH: "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}-publish"

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
    - docker build --cache-from $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $IMAGE_TEST --target gitlab .
    - docker build --cache-from $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $IMAGE_PUBLISH --target publish .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $IMAGE_TEST
    - docker push $IMAGE_PUBLISH
    - if [ "$CI_COMMIT_BRANCH" = "master" ]; then
    - docker push $CI_REGISTRY_IMAGE:latest
    - fi
  tags:
    - cg
    - shell

test:
  stage: test
  image: $IMAGE_TEST
  services:
    - postgres:11-alpine
    - redis
  variables:
    POSTGRES_USER: "vlc"
    POSTGRES_PASSWORD: "vlc"
    POSTGRES_DB: "vlc"
    DB_HOST: "postgres"
    DJANGO_SETTINGS_MODULE: "vlc.conf.gitlab"
  script:
    - coverage run src/manage.py test vlc
    - coverage report
    - coverage xml
  tags:
    - cg
    - docker
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

pages:
  stage: pages
  image: $IMAGE_PUBLISH
  variables:
    DJANGO_SETTINGS_MODULE: "vlc.conf.gitlab"
  script:
    - sphinx-build ./docs public
  artifacts:
    paths:
      - public
  tags:
    - cg
    - docker
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
